#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
 #include <avr/power.h> // Required for 16 MHz Adafruit Trinket
#endif

// Which pin on the Arduino is connected to the NeoPixels?
// On a Trinket or Gemma we suggest changing this to 1:
#define LED_PIN     48

// How many NeoPixels are attached to the Arduino?
#define LED_COUNT  8

// NeoPixel brightness, 0 (min) to 255 (max)
#define BRIGHTNESS 50 // Set BRIGHTNESS to about 1/5 (max = 255)

// Declare our NeoPixel strip object:
Adafruit_NeoPixel strip(LED_COUNT, LED_PIN, NEO_GRBW + NEO_KHZ800);
// Argument 1 = Number of pixels in NeoPixel strip
// Argument 2 = Arduino pin number (most are valid)
// Argument 3 = Pixel type flags, add together as needed:
//   NEO_KHZ800  800 KHz bitstream (most NeoPixel products w/WS2812 LEDs)
//   NEO_KHZ400  400 KHz (classic 'v1' (not v2) FLORA pixels, WS2811 drivers)
//   NEO_GRB     Pixels are wired for GRB bitstream (most NeoPixel products)
//   NEO_RGB     Pixels are wired for RGB bitstream (v1 FLORA pixels, not v2)
//   NEO_RGBW    Pixels are wired for RGBW bitstream (NeoPixel RGBW products)
int whichColor = 1;

// digital pin 2 has a pushbutton attached to it. Give it a name:
int greenLED1 = 2;
int greenLED2 = 3;
int greenLED3 = 4;
int greenLED4 = 15;
int greenLED5 = 6;
int greenLED6 = 7;
int greenLED7 = 8;
int greenLED8 = 9;
int greenLED9 = 10;
int greenLED10 = 11;
int greenLED11 = 12;
int greenLED12 = 14;

int pushButton1 = 22;
int pushButton2 = 24;
int pushButton3 = 5;
int pushButton4 = 28;
int pushButton5 = 30;
int pushButton6 = 32;
int pushButton7 = 34;
int pushButton8 = 36;
int pushButton9 = 38;
int pushButton10 = 40;
int pushButton11 = 42;
int pushButton12 = 44;

int pushButtonRed = 20;
int pushButtonRedLED= 21;

int buttonState1;
int buttonState2;
int buttonState3;
int buttonState4;
int buttonState5;
int buttonState6;
int buttonState7;
int buttonState8;
int buttonState9;
int buttonState10;
int buttonState11;
int buttonState12;
int buttonStateRed;

int lastButtonState1;
int lastButtonState2;
int lastButtonState3;
int lastButtonState4;
int lastButtonState5;
int lastButtonState6;
int lastButtonState7;
int lastButtonState8;
int lastButtonState9;
int lastButtonState10;
int lastButtonState11;
int lastButtonState12;
int lastButtonStateRed;

int buttonPushCounter1;
int buttonPushCounter2;
int buttonPushCounter3;
int buttonPushCounter4;
int buttonPushCounter5;
int buttonPushCounter6;
int buttonPushCounter7;
int buttonPushCounter8;
int buttonPushCounter9;
int buttonPushCounter10;
int buttonPushCounter11;
int buttonPushCounter12;
int buttonPushCounterRed;

uint32_t color;

// the setup routine runs once when you press reset:
void setup() {
  strip.begin();           // INITIALIZE NeoPixel strip object (REQUIRED)
  strip.show();            // Turn OFF all pixels ASAP
  strip.setBrightness(BRIGHTNESS);

  // initialize serial communication at 9600 bits per second:
  Serial.begin(9600);
  // make the pushbutton's pin an input:
  pinMode(greenLED1, OUTPUT);
  pinMode(greenLED2, OUTPUT);
  pinMode(greenLED3, OUTPUT);
  pinMode(greenLED4, OUTPUT);
  pinMode(greenLED5, OUTPUT);
  pinMode(greenLED6, OUTPUT);
  pinMode(greenLED7, OUTPUT);
  pinMode(greenLED8, OUTPUT);
  pinMode(greenLED9, OUTPUT);
  pinMode(greenLED10, OUTPUT);
  pinMode(greenLED11, OUTPUT);
  pinMode(greenLED12, OUTPUT);

  pinMode(pushButton1, INPUT_PULLUP);
  pinMode(pushButton2, INPUT_PULLUP);
  pinMode(pushButton3, INPUT_PULLUP);
  pinMode(pushButton4, INPUT_PULLUP);
  pinMode(pushButton5, INPUT_PULLUP);
  pinMode(pushButton6, INPUT_PULLUP);
  pinMode(pushButton7, INPUT_PULLUP);
  pinMode(pushButton8, INPUT_PULLUP);
  pinMode(pushButton9, INPUT_PULLUP);
  pinMode(pushButton10, INPUT_PULLUP);
  pinMode(pushButton11, INPUT_PULLUP);
  pinMode(pushButton12, INPUT_PULLUP);

  pinMode(pushButtonRed, INPUT_PULLUP);
  pinMode(pushButtonRedLED, OUTPUT);
}

// the loop routine runs over and over again forever:
void loop() {
  if (whichColor == 1){
  color = strip.Color(255,   0,   0, 30);
  } else{
  color = strip.Color(0,   0,   0, 0);
  }
for(int i=strip.numPixels(); i>=0; i--) {
  strip.setPixelColor(i, color);         //  Set pixel's color (in RAM)
    strip.show();                          //  Update strip to match
  //read the input pin:
  buttonState1 = digitalRead(pushButton1);
  buttonState2 = digitalRead(pushButton2);
  buttonState3 = digitalRead(pushButton3);
  buttonState4 = digitalRead(pushButton4);
  buttonState5 = digitalRead(pushButton5);
  buttonState6 = digitalRead(pushButton6);
  buttonState7 = digitalRead(pushButton7);
  buttonState8 = digitalRead(pushButton8);
  buttonState9 = digitalRead(pushButton9);
  buttonState10 = digitalRead(pushButton10);
  buttonState11 = digitalRead(pushButton11);
  buttonState12 = digitalRead(pushButton12);
  buttonStateRed = digitalRead(pushButtonRed);
  //print out the state of the button:
  Serial.print(buttonState1);
  Serial.print(", ");
  Serial.print(buttonState2);
  Serial.print(", ");
  Serial.print(buttonState3);
  Serial.print(", ");
  Serial.print(buttonState4);
  Serial.print(", ");
  Serial.print(buttonState5);
  Serial.print(", ");
  Serial.print(buttonState6);
  Serial.print(", ");
  Serial.print(buttonState7);
  Serial.print(", ");
  Serial.print(buttonState8);
  Serial.print(", ");
  Serial.print(buttonState9);
  Serial.print(", ");
  Serial.print(buttonState10);
  Serial.print(", ");
  Serial.print(buttonState11);
  Serial.print(", ");
  Serial.print(buttonState12);
  Serial.print(", ");
  Serial.println(buttonStateRed);


  // compare the buttonState to its previous state
  if (buttonState1 != lastButtonState1) { // if the state has changed, increment the counter
    if (buttonState1 == LOW) { // if the current state is HIGH then the button went from off to on:
      buttonPushCounter1++;
      Serial.println("on");
      Serial.print("number of button pushes: ");
      Serial.println(buttonPushCounter1);
    } else {
      Serial.println("off"); // if the current state is LOW then the button went from on to off:
    }
    delay(50); // Delay a little bit to avoid bouncing
  }
  lastButtonState1 = buttonState1; // save the current state as the last state, for next time through the loop

  if ((buttonPushCounter1 % 2) == 0){
    digitalWrite(greenLED1, HIGH);
  } else{
    digitalWrite(greenLED1, LOW);
  }
    // compare the buttonState to its previous state
  if (buttonState2 != lastButtonState2) { // if the state has changed, increment the counter
    if (buttonState2 == LOW) { // if the current state is HIGH then the button went from off to on:
      buttonPushCounter2++;
      Serial.println("on");
      Serial.print("number of button pushes: ");
      Serial.println(buttonPushCounter2);
    } else {
      Serial.println("off"); // if the current state is LOW then the button went from on to off:
    }
    delay(50); // Delay a little bit to avoid bouncing
  }
  lastButtonState2 = buttonState2; // save the current state as the last state, for next time through the loop

  if ((buttonPushCounter2 % 2) == 0){
    digitalWrite(greenLED2, HIGH);
  } else{
    digitalWrite(greenLED2, LOW);
  }
  // compare the buttonState to its previous state
  if (buttonState3 != lastButtonState3) { // if the state has changed, increment the counter
    if (buttonState3 == LOW) { // if the current state is HIGH then the button went from off to on:
      buttonPushCounter3++;
      Serial.println("on");
      Serial.print("number of button pushes: ");
      Serial.println(buttonPushCounter3);
    } else {
      Serial.println("off"); // if the current state is LOW then the button went from on to off:
    }
    delay(50); // Delay a little bit to avoid bouncing
  }
  lastButtonState3 = buttonState3; // save the current state as the last state, for next time through the loop

  if ((buttonPushCounter3 % 2) == 0){
    digitalWrite(greenLED3, HIGH);
  } else{
    digitalWrite(greenLED3, LOW);
  }

    // compare the buttonState to its previous state
  if (buttonState4 != lastButtonState4) { // if the state has changed, increment the counter
    if (buttonState4 == LOW) { // if the current state is HIGH then the button went from off to on:
      buttonPushCounter4++;
      Serial.println("on");
      Serial.print("number of button pushes: ");
      Serial.println(buttonPushCounter4);
    } else {
      Serial.println("off"); // if the current state is LOW then the button went from on to off:
    }
    delay(50); // Delay a little bit to avoid bouncing
  }
  lastButtonState4 = buttonState4; // save the current state as the last state, for next time through the loop

  if ((buttonPushCounter4 % 2) == 0){
    digitalWrite(greenLED4, HIGH);
  } else{
    digitalWrite(greenLED4, LOW);
  }

    // compare the buttonState to its previous state
  if (buttonState5 != lastButtonState5) { // if the state has changed, increment the counter
    if (buttonState5 == LOW) { // if the current state is HIGH then the button went from off to on:
      buttonPushCounter5++;
      Serial.println("on");
      Serial.print("number of button pushes: ");
      Serial.println(buttonPushCounter5);
    } else {
      Serial.println("off"); // if the current state is LOW then the button went from on to off:
    }
    delay(50); // Delay a little bit to avoid bouncing
  }
  lastButtonState5 = buttonState5; // save the current state as the last state, for next time through the loop

  if ((buttonPushCounter5 % 2) == 0){
    digitalWrite(greenLED5, HIGH);
  } else{
    digitalWrite(greenLED5, LOW);
  }

    // compare the buttonState to its previous state
  if (buttonState6 != lastButtonState6) { // if the state has changed, increment the counter
    if (buttonState6 == LOW) { // if the current state is HIGH then the button went from off to on:
      buttonPushCounter6++;
      Serial.println("on");
      Serial.print("number of button pushes: ");
      Serial.println(buttonPushCounter6);
    } else {
      Serial.println("off"); // if the current state is LOW then the button went from on to off:
    }
    delay(60); // Delay a little bit to avoid bouncing
  }
  lastButtonState6 = buttonState6; // save the current state as the last state, for next time through the loop

  if ((buttonPushCounter6 % 2) == 0){
    digitalWrite(greenLED6, HIGH);
  } else{
    digitalWrite(greenLED6, LOW);
  }

    // compare the buttonState to its previous state
  if (buttonState7 != lastButtonState7) { // if the state has changed, increment the counter
    if (buttonState7 == LOW) { // if the current state is HIGH then the button went from off to on:
      buttonPushCounter7++;
      Serial.println("on");
      Serial.print("number of button pushes: ");
      Serial.println(buttonPushCounter7);
    } else {
      Serial.println("off"); // if the current state is LOW then the button went from on to off:
    }
    delay(70); // Delay a little bit to avoid bouncing
  }
  lastButtonState7 = buttonState7; // save the current state as the last state, for next time through the loop

  if ((buttonPushCounter7 % 2) == 0){
    digitalWrite(greenLED7, HIGH);
  } else{
    digitalWrite(greenLED7, LOW);
  }

    // compare the buttonState to its previous state
  if (buttonState8 != lastButtonState8) { // if the state has changed, increment the counter
    if (buttonState8 == LOW) { // if the current state is HIGH then the button went from off to on:
      buttonPushCounter8++;
      Serial.println("on");
      Serial.print("number of button pushes: ");
      Serial.println(buttonPushCounter8);
    } else {
      Serial.println("off"); // if the current state is LOW then the button went from on to off:
    }
    delay(80); // Delay a little bit to avoid bouncing
  }
  lastButtonState8 = buttonState8; // save the current state as the last state, for next time through the loop

  if ((buttonPushCounter8 % 2) == 0){
    digitalWrite(greenLED8, HIGH);
  } else{
    digitalWrite(greenLED8, LOW);
  }

    // compare the buttonState to its previous state
  if (buttonState9 != lastButtonState9) { // if the state has changed, increment the counter
    if (buttonState9 == LOW) { // if the current state is HIGH then the button went from off to on:
      buttonPushCounter9++;
      Serial.println("on");
      Serial.print("number of button pushes: ");
      Serial.println(buttonPushCounter9);
    } else {
      Serial.println("off"); // if the current state is LOW then the button went from on to off:
    }
    delay(90); // Delay a little bit to avoid bouncing
  }
  lastButtonState9 = buttonState9; // save the current state as the last state, for next time through the loop

  if ((buttonPushCounter9 % 2) == 0){
    digitalWrite(greenLED9, HIGH);
  } else{
    digitalWrite(greenLED9, LOW);
  }

    // compare the buttonState to its previous state
  if (buttonState10 != lastButtonState10) { // if the state has changed, increment the counter
    if (buttonState10 == LOW) { // if the current state is HIGH then the button went from off to on:
      buttonPushCounter10++;
      Serial.println("on");
      Serial.print("number of button pushes: ");
      Serial.println(buttonPushCounter10);
    } else {
      Serial.println("off"); // if the current state is LOW then the button went from on to off:
    }
    delay(100); // Delay a little bit to avoid bouncing
  }
  lastButtonState10 = buttonState10; // save the current state as the last state, for next time through the loop

  if ((buttonPushCounter10 % 2) == 0){
    digitalWrite(greenLED10, HIGH);
  } else{
    digitalWrite(greenLED10, LOW);
  }

    // compare the buttonState to its previous state
  if (buttonState11 != lastButtonState11) { // if the state has changed, increment the counter
    if (buttonState11 == LOW) { // if the current state is HIGH then the button went from off to on:
      buttonPushCounter11++;
      Serial.println("on");
      Serial.print("number of button pushes: ");
      Serial.println(buttonPushCounter11);
    } else {
      Serial.println("off"); // if the current state is LOW then the button went from on to off:
    }
    delay(110); // Delay a little bit to avoid bouncing
  }
  lastButtonState11 = buttonState11; // save the current state as the last state, for next time through the loop

  if ((buttonPushCounter11 % 2) == 0){
    digitalWrite(greenLED11, HIGH);
  } else{
    digitalWrite(greenLED11, LOW);
  }

    // compare the buttonState to its previous state
  if (buttonState12 != lastButtonState12) { // if the state has changed, increment the counter
    if (buttonState12 == LOW) { // if the current state is HIGH then the button went from off to on:
      buttonPushCounter12++;
      Serial.println("on");
      Serial.print("number of button pushes: ");
      Serial.println(buttonPushCounter12);
    } else {
      Serial.println("off"); // if the current state is LOW then the button went from on to off:
    }
    delay(120); // Delay a little bit to avoid bouncing
  }
  lastButtonState12 = buttonState12; // save the current state as the last state, for next time through the loop

  if ((buttonPushCounter12 % 2) == 0){
    digitalWrite(greenLED12, HIGH);
  } else{
    digitalWrite(greenLED12, LOW);
  }

    // compare the buttonState to its previous state
  if (buttonStateRed != lastButtonStateRed) { // if the state has changed, increment the counter
    if (buttonStateRed == LOW) { // if the current state is HIGH then the button went from off to on:
      buttonPushCounterRed++;
      Serial.println("on");
      Serial.print("number of button pushes: ");
      Serial.println(buttonPushCounterRed);
    } else {
      Serial.println("off"); // if the current state is LOW then the button went from on to off:
    }
    delay(50); // Delay a little bit to avoid bouncing
  }
  lastButtonStateRed = buttonStateRed; // save the current state as the last state, for next time through the loop

  if ((buttonPushCounterRed % 2) == 0){
    digitalWrite(pushButtonRedLED, HIGH);
  } else{
    digitalWrite(pushButtonRedLED, LOW);
  }
   
  //  digitalWrite(greenLED3, HIGH);
  //  digitalWrite(greenLED4, HIGH);
  //  digitalWrite(greenLED5, HIGH);
  //  digitalWrite(greenLED6, HIGH);
  //  digitalWrite(greenLED7, HIGH);
  //  digitalWrite(greenLED8, HIGH);
  //  digitalWrite(greenLED9, HIGH);
  //  digitalWrite(greenLED10, HIGH);
  //  digitalWrite(greenLED11, HIGH);
  //  digitalWrite(greenLED12, HIGH);

   //digitalWrite(pushButtonRedLED, HIGH);
  delay(3);  // delay in between reads for stability
  }
  whichColor = !whichColor;
}
